[BACK]Return to ipfilter CVS log [TXT][DIR] Up to [cvs.NetBSD.org] / src / etc / rc.d

File: [cvs.NetBSD.org] / src / etc / rc.d / ipfilter (download)

Revision 1.4.4.1, Wed Aug 9 18:45:22 2000 UTC (18 years, 6 months ago) by lukem
Branch: netbsd-1-5
CVS Tags: netbsd-1-5-ALPHA2
Changes since 1.4: +28 -9 lines

pull up revs 1.5-1.6
approved by: thorpej

* add support for `status'
* if ipf.conf isn't readable and the system is booting directly to multiuser,
  send SIGTERM to the parent (/etc/rc) so that init(8) aborts the boot.

#!/bin/sh
#
# $NetBSD: ipfilter,v 1.4.4.1 2000/08/09 18:45:22 lukem Exp $
#

# PROVIDE: ipfilter
# REQUIRE: root beforenetlkm mountcritlocal tty

. /etc/rc.subr

name="ipfilter"
start_precmd="ipfilter_prestart"
start_cmd="ipfilter_start"
stop_precmd="checkyesno ipfilter && [ -f /etc/ipf.conf ]"
stop_cmd="ipfilter_stop"
reload_precmd="$stop_precmd"
reload_cmd="ipfilter_reload"
status_precmd="$stop_precmd"
status_cmd="ipfilter_status"
extra_commands="reload status"

ipfilter_prestart()
{
	if ! checkyesno ipfilter; then
		return 1
	fi
	if [ ! -f /etc/ipf.conf ]; then
		warn "/etc/ipf.conf not readable; ipfilter start aborted."
			#
			# If booting directly to multiuser, send SIGTERM to
			# the parent (/etc/rc) to abort the boot
			#
		if [ "$autoboot" = yes ]; then
			echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
			kill -TERM $$
			exit 1
		fi
		return 1
	fi
	return 0
}

ipfilter_start()
{
	echo "Enabling ipfilter."
	/sbin/ipf -E -Fa -f /etc/ipf.conf
}

ipfilter_stop()
{
	echo "Disabling ipfilter."
	/sbin/ipf -D
}

ipfilter_reload()
{
	echo "Reloading ipfilter rules."
	/sbin/ipf -I -Fa -f /etc/ipf.conf
	if [ $? -eq 0 ]; then
		/sbin/ipf -s
	else
		warn "Reload failed; not swapping to new ruleset."
	fi
}

ipfilter_status()
{
	/sbin/ipf -V
}

load_rc_config $name
run_rc_command "$1"